"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildAgentSource = void 0;
const mustache_1 = __importDefault(require("mustache"));
const mod_js_1 = require("../wrappers/mod.js");
const config_js_1 = require("../config.js");
const partial_lookup_js_1 = require("./partial-lookup.js");
const AGENT_MUSTACHE = 'agent.mustache';
async function buildAgentSource(metadata) {
    config_js_1.log.verbose('Sidecar', 'buildAgentSource("%s...")', JSON.stringify(metadata).substr(0, 20));
    // log.silly('Sidecar', 'buildAgentSource(%s)', JSON.stringify(metadata))
    const agentMustache = (0, partial_lookup_js_1.partialLookup)(AGENT_MUSTACHE);
    const view = (0, mod_js_1.wrapView)(metadata);
    const source = await mustache_1.default.render(agentMustache, view, partial_lookup_js_1.partialLookup);
    return source;
}
exports.buildAgentSource = buildAgentSource;
//# sourceMappingURL=build-agent-source.js.map