#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const partial_lookup_js_1 = require("./partial-lookup.js");
const cjs_js_1 = require("../cjs.js");
(0, tstest_1.test)('partialLookup()', async (t) => {
    const EXPECTED_STR = fs_1.default.readFileSync(path_1.default.join(cjs_js_1.codeRoot, 'src', 'agent', 'templates/libs/log.cjs'), 'utf-8');
    const source = await (0, partial_lookup_js_1.partialLookup)('libs/log.cjs');
    t.equal(source, EXPECTED_STR, 'should get right partial file content');
});
//# sourceMappingURL=partial-lookup.spec.js.map