#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const mustache_1 = __importDefault(require("mustache"));
const partial_lookup_js_1 = require("../partial-lookup.js");
const chatbox_sidecar_js_1 = require("../../../examples/chatbox-sidecar.js");
const mod_js_1 = require("../../wrappers/mod.js");
const metadata_sidecar_js_1 = require("../../decorators/sidecar/metadata-sidecar.js");
(0, tstest_1.test)('agent.mustache', async (t) => {
    const view = (0, metadata_sidecar_js_1.getMetadataSidecar)(chatbox_sidecar_js_1.ChatboxSidecar);
    // console.log(JSON.stringify(view, null, 2))
    const wrappedView = (0, mod_js_1.wrapView)(view);
    // console.log(JSON.stringify(wrappedView, null, 2))
    // console.log(Object.keys(wrappedView))
    const template = await (0, partial_lookup_js_1.partialLookup)('agent.mustache');
    // console.log(template)
    const result = mustache_1.default.render(template, {
        ...wrappedView,
        initAgentScript: 'console.log("hello")',
    }, partial_lookup_js_1.partialLookup);
    // console.log('result:', result)
    /**
     * Huan(202106): how could we test this script has been correctly generated?
     */
    t.ok(result, 'should render to the right script (TBW)');
});
//# sourceMappingURL=agent.spec.js.map