"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMetadataCall = exports.updateMetadataCall = void 0;
const config_js_1 = require("../../config.js");
const constants_js_1 = require("./constants.js");
function updateMetadataCall(target, propertyKey, functionTarget) {
    config_js_1.log.verbose('Sidecar', 'updateMetadataCall(%s, %s, %s)', target.constructor.name, propertyKey, typeof functionTarget === 'object' ? JSON.stringify(functionTarget)
        : typeof functionTarget === 'number' ? functionTarget.toString(16)
            : functionTarget);
    // Update the parameter names
    Reflect.defineMetadata(constants_js_1.CALL_SYMBOL, functionTarget, target, propertyKey);
}
exports.updateMetadataCall = updateMetadataCall;
function getMetadataCall(target, propertyKey) {
    // Pull the array of parameter names
    const fridaTarget = Reflect.getMetadata(constants_js_1.CALL_SYMBOL, target, propertyKey);
    return fridaTarget;
}
exports.getMetadataCall = getMetadataCall;
//# sourceMappingURL=metadata-call.js.map