"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateMetadataParamType = exports.getMetadataParamType = void 0;
const constants_js_1 = require("./constants.js");
function updateMetadataParamType(target, propertyKey, parameterIndex, typeChain) {
    // Pull the array of parameter names
    const parameterTypeList = Reflect.getOwnMetadata(constants_js_1.PARAM_TYPE_SYMBOL, target, propertyKey) || [];
    // Add the current parameter name
    parameterTypeList[parameterIndex] = typeChain;
    // Update the parameter names
    Reflect.defineMetadata(constants_js_1.PARAM_TYPE_SYMBOL, parameterTypeList, target, propertyKey);
}
exports.updateMetadataParamType = updateMetadataParamType;
function getMetadataParamType(target, propertyKey) {
    // Pull the array of parameter names
    const parameterTypeList = Reflect.getMetadata(constants_js_1.PARAM_TYPE_SYMBOL, target, propertyKey);
    return parameterTypeList || [];
}
exports.getMetadataParamType = getMetadataParamType;
//# sourceMappingURL=metadata-param-type.js.map