"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RetType = void 0;
const config_js_1 = require("../../config.js");
const metadata_ret_type_js_1 = require("./metadata-ret-type.js");
const guard_ret_type_js_1 = require("./guard-ret-type.js");
function RetType(nativeType, ...pointerTypeList) {
    config_js_1.log.verbose('Sidecar', '@RetType(%s%s)', nativeType, pointerTypeList.length > 0
        ? `, [${pointerTypeList.join(',')}]`
        : '');
    return function retTypeMethodDecorator(target, propertyKey, _descriptor) {
        config_js_1.log.verbose('Sidecar', '@RetType(%s%s) retTypeMethodDecorator(%s, %s, descriptor)', nativeType, pointerTypeList.length > 0
            ? `, [${pointerTypeList.join(',')}]`
            : '', target.constructor.name, propertyKey);
        (0, guard_ret_type_js_1.guardRetType)(target, propertyKey, nativeType, pointerTypeList);
        (0, metadata_ret_type_js_1.updateMetadataRetType)(target, propertyKey, [nativeType, ...pointerTypeList]);
    };
}
exports.RetType = RetType;
//# sourceMappingURL=ret-type.js.map