"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.declareJsArgs = void 0;
const name_helpers_js_1 = require("./name-helpers.js");
function declareJsArgs() {
    const typeList = this.paramTypeList;
    // if (!typeList) {
    //   throw new Error('no .paramTypeList found in SidecarMetadataFunctionDescription!')
    // }
    const argDeclarationList = [];
    for (const [idx, typeChain] of typeList.entries()) {
        const [nativeType, ...pointerTypeList] = typeChain;
        // console.log(nativeType, pointerTypeList)
        const readChain = [
            (0, name_helpers_js_1.argName)(idx),
        ];
        /**
         * 1. native pointer
         */
        if (nativeType === 'pointer') {
            for (const pointerType of pointerTypeList) {
                readChain.push(`.read${pointerType}()`);
            }
        }
        const declaration = 'const ' + (0, name_helpers_js_1.jsArgName)(this.name, idx) + ' = ' + readChain.join('');
        argDeclarationList.push(declaration);
    }
    return argDeclarationList.join('\n');
}
exports.declareJsArgs = declareJsArgs;
//# sourceMappingURL=declare-js-args.js.map